
//--------------------------------------------------------------------------
// Large Bunker
//
//
//--------------------------------------------------------------------------

$TeamDeployableMax[BunkerDeployable] = 1;//was3 v2.0-RED
$TeamDeployableMin[BunkerDeployable] = 1;
//explosion////////////////////////////////
///////////////////////////////////////////
datablock ExplosionData(BunkerExplosion)
{
   explosionShape = "mortar_explosion.dts";
   playSpeed = 1.5;
   soundProfile = BombExplosionSound;
   faceViewer = true;

   emitter[0] = VehicleMESmokeEmitter;

   debris = VehicleFireballDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 4;
   debrisNumVariance = 1;
   debrisVelocity = 20.0;
   debrisVelocityVariance = 5.0;

   subExplosion = VSpikeExplosion;

   shakeCamera = true;
   camShakeFreq = "11.0 13.0 9.0";
   camShakeAmp = "40.0 40.0 40.0";
   camShakeDuration = 0.7;
   camShakeRadius = 25.0;
};
/////////////////////////////////////////////

datablock StaticShapeData(DeployedBunker) : StaticShapeDamageProfile
{
   className = Bunker;
   shapeFile = "dmiscf.dts"; // dmiscf.dts, alternatePmiscf
   maxDamage = 20.0;//was40 v2.0-RED
   destroyedLevel = 20.0;
   disabledLevel = 20.0;
   explosion = BunkerExplosion;
   expDmgRadius = 12.0;
   expDamage = 0.8;
   expImpulse = 2000.0;
   
   dynamicType = $TypeMasks::StaticShapeObjectType;
   deployedObject = true;
   cmdCategory = "DSupport";
   cmdIcon = CMDSensorIcon;
   cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
   targetNameTag = 'Large';
   targetTypeTag = 'Bunker';
   deployAmbientThread = true;
   heatSignature = 0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitterOffset[0] = "1.0 1.0 1.0 ";
   damageLevelTolerance[0] = 2.0;
   damageLevelTolerance[1] = 5.0;
   numDmgEmitterAreas = 1;
};

datablock StaticShapeData(DeployedBunker2) : StaticShapeDamageProfile
{
   className = Bunker;
   shapeFile = "dmiscf.dts"; // dmiscf.dts, alternate Pmiscf
   maxDamage = 20.0;
   destroyedLevel = 20.0;
   disabledLevel = 20.0;
   explosion = BunkerExplosion;
   expDmgRadius = 12.0;
   expDamage = 0.8;
   expImpulse = 2000.0;


   dynamicType = $TypeMasks::StaticShapeObjectType;
   deployedObject = true;
   targetNameTag = 'Large';
   targetTypeTag = 'Bunker';
   deployAmbientThread = true;
   heatSignature = 0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitterOffset[0] = "1.0 1.0 1.0 ";
   damageLevelTolerance[0] = 2.0;
   damageLevelTolerance[1] = 5.0;
   numDmgEmitterAreas = 1;
};

datablock ShapeBaseImageData(BunkerDeployableImage)
{
   mass = 20;
   emap = true;
   shapeFile = "Stackable1s.dts";
   item = BunkerDeployable;
   mountPoint = 1;
   offset = "0 0 0";
   deployed = DeployedBunker;
   heatSignature = 0;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateTransitionOnTriggerUp[1] = "Idle";

   isLarge = true;
   maxDepSlope = 360; // 30
   deploySound = ItemPickupSound;

   minDeployDis = 0.5;
   maxDeployDis = 5.0;
};

datablock ItemData(BunkerDeployable)
{
   className = Pack;
   catagory = "Deployables";
   shapeFile = "Stackable1s.dts";
   mass = 5.0;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 1;
   rotate = true;
   image = "BunkerDeployableImage";
   pickUpName = "a large bunker";
   heatSignature = 0;
   emap = true;
};

datablock ForceFieldBareData(BunkerForceField) : StaticShapeDamageProfile
{
   fadeMS = 1000;
   baseTranslucency = 0.5;
   powerOffTranslucency = 0.0;
   teamPermiable = true;
   otherPermiable = false;
   color            = "0.0 0.6 0.2";
   powerOffColor    = "0.0 0.0 0.0";
   cmdIcon = CMDSwitchIcon;
   cmdCategory = "DSupport";
   cmdMiniIconName = "commander/MiniIcons/com_switch_grey";
   targetNameTag = 'Deployed';
   targetTypeTag = 'ForceField';
   texture[0] = "skins/forcef1";
   texture[1] = "skins/forcef2";
   texture[2] = "skins/forcef3";
   texture[3] = "skins/forcef4";
   texture[4] = "skins/forcef5";
   framesPerSec = 10;
   numFrames = 5;
   scrollSpeed = 15;
   umapping = 1.0;
   vmapping = 0.15;
};

function BunkerDeployable::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}

function BunkerDeployableImage::onDeploy(%item, %plyr, %slot)
{
   %plyr.unmountImage(%slot);
   %plyr.decInventory(%item.item, 1);
   %rot = %item.getInitialRotation(%plyr);
   %vec = %plyr.getEyeVector();
   %vec = getWord(%vec, 0) SPC getWord(%vec, 1) SPC "0";
   %classname = "StaticShape";
   %d2 = -1 * getWord(%rot, 2) * getWord(%rot, 3);
   %rot2 = "0 1.57 " @ %d2 + 1.57;
   %mat = MatrixCreateFromEuler(%rot2);
   %pointone = VectorAdd(%item.surfacePt, VectorScale(%vec, 7.5));
   %rot2 = "0 1.57 " @ %d2;
   %mat2 = MatrixCreateFromEuler(%rot2);
   %x2 = getWord(%vec, 0);
   %y2 = getWord(%vec, 1);
   %vec2 = %y2 SPC %x2 * -1 SPC "0";
   %pointtwo = VectorAdd(%item.surfacePt, VectorScale(%vec2, 7.5));
   %rot2 = "0 1.57 " @ %d2 + 3.14;
   %mat3 = MatrixCreateFromEuler(%rot2);
   %vec3 = %y2 * -1 SPC %x2 SPC "0";
   %pointthree = VectorAdd(%item.surfacePt, VectorScale(%vec3, 7.5));
   %rot2 = "0 0 " @ %d2;
   %mat4 = MatrixCreateFromEuler(%rot2);
   %x2 = getWord(%vec, 0);
   %y2 = getWord(%vec, 1);
   %vec4 = "0 0 6.6";
   %pointfour = VectorAdd(%item.surfacePt, %vec4);
   %vec5 = "0 0 7.1";
   %pointfive = VectorAdd(%item.surfacePt, %vec5);
   %pointsix = VectorAdd(%item.surfacePt, VectorScale(%vec, -7.5));
   %pointseven = VectorAdd(%item.surfacePt, VectorScale(%vec, 4.5));
   %pointseven = VectorAdd(%pointseven, "0 0 0.5");
   %fieldpos = VectorAdd(%pointthree, VectorScale(%vec, -7.4));
   %width = VectorDist(%pointthree, %pointtwo);
   %length = VectorDist(%pointone, %pointsix);
   %height = VectorDist(%item.surfacePt, %pointfour);
   %deplObj = new (%className)() //Front Wall
   {
      dataBlock = %item.deployed;
      scale = %height / 3.6 SPC %width / 2.95 SPC "1";
   };
   %deplObj2 = new (%className)() //Right Wall
   {
      dataBlock = DeployedBunker2;
      scale = %height / 3.6 SPC %length / 2.95 SPC "1";
   };
   %deplObj3 = new (%className)()  //Left Wall
   {
      dataBlock = DeployedBunker2;
      scale = %height / 3.6 SPC %length / 2.95 SPC "1";
   };
   %deplObj4 = new (%className)()  //Ceiling
   {
      dataBlock = DeployedBunker2;
      scale = %width / 3.7 SPC %length / 2.95 SPC "1";
   };
   %deplObj5 = new (%className)()  //Floor
   {
      dataBlock = DeployedBunker2;
      scale = %width / 3.7 SPC %length / 2.95 SPC "1";
   };
   %deplObj6 = new Turret()  //TurretBase
   {
      dataBlock = TurretBaseLarge;
   };
   %x1 = getWord(%vec, 0);
   %y1 = getWord(%vec, 1);
   if ((%x1 > 0) && (%y1 >= 0))
   {
      %zone = 0;
      %rad = mAtan(%x1, %y1);
   }
   else if((%x1 >= 0) && (%y1 < 0))
   {
      %zone = 1;
      %y1 *= -1;
      %rad = mAtan(%y1, %x1);
   }
   else if((%x1 < 0) && (%y1 <= 0))
   {
      %zone = 2;
      %y1 *= -1;
      %x1 *= -1;
      %rad = mAtan(%x1, %y1);
   }
   else if((%x1 <= 0) && (%y1 > 0))
   {
      %zone = 3;
      %x1 *= -1;
      %rad = mAtan(%y1, %x1);
   }
   %angle = mRadtoDeg(%rad);
   if (%zone == 1)
      %angle += 90;
   else if (%zone == 2)
      %angle += 180;
   else if (%zone == 3)
      %angle += 270;
   %fieldrot = " 0 0 1 " @ %angle;
   %deplObj.setTransform(VectorAdd(%pointone, "0 0 3.5") SPC getWord(%mat, 3) SPC getWord(%mat, 4) SPC GetWord(%mat, 5) SPC getWord(%mat, 6));
   %deplObj2.setTransform(VectorAdd(%pointtwo, "0 0 3.5") SPC getWord(%mat2, 3) SPC getWord(%mat2, 4) SPC GetWord(%mat2, 5) SPC getWord(%mat2, 6));
   %deplObj3.setTransform(VectorAdd(%pointthree, "0 0 3.5") SPC getWord(%mat3, 3) SPC getWord(%mat3, 4) SPC GetWord(%mat3, 5) SPC getWord(%mat3, 6));
   %deplObj4.setTransform(%pointfour SPC getWord(%mat4, 3) SPC getWord(%mat4, 4) SPC GetWord(%mat4, 5) SPC getWord(%mat4, 6));
   %deplObj5.setTransform(%item.surfacePt SPC getWord(%mat4, 3) SPC getWord(%mat4, 4) SPC GetWord(%mat4, 5) SPC getWord(%mat4, 6));
   %deplObj6.setTransform(%pointfive SPC %rot);
   %deplObj7 = new (%className)()  //Inventory Station
   {
      dataBlock = StationInventory;
      position = %pointseven;
      rotation = %fieldrot;
   };
   %deplObj.field = new ForceFieldBare() //ForceField
   {
      position = %fieldpos;
      rotation = %fieldrot;
      scale = %width @ " 0.02 6.6";
      dataBlock = "BunkerForceField";
      owner = %deplObj;
      team = %plyr.team;
   };

   %deplObj.field.active = true;
   %deplObj6.mountImage(MissileBarrelLarge, 0, false);
   %deplObj6.setSelfPowered();
   %deplObj6.playThread($PowerThread,"Power");
   %deplObj7.setSelfPowered();
   %deplObj7.playThread($PowerThread,"Power");
   MissionCleanup.add(%deplObj.field);

   %deplObj.team = %plyr.client.Team;
   %deplObj.owner = %plyr.client;
   %deplObj2.team = %plyr.client.Team;
   %deplObj2.owner = %plyr.client;
   %deplObj3.team = %plyr.client.Team;
   %deplObj3.owner = %plyr.client;
   %deplObj4.team = %plyr.client.Team;
   %deplObj4.owner = %plyr.client;
   %deplObj5.team = %plyr.client.Team;
   %deplObj5.owner = %plyr.client;
   %deplObj6.team = %plyr.client.Team;
   %deplObj6.owner = %plyr.client;
   %deplObj7.team = %plyr.client.Team;
   %deplObj7.owner = %plyr.client;
   %deplObj.field.team = %plyr.client.Team;
   %deplObj.field.pzone.team = %plyr.client.Team;

   // set the sensor group if it needs one
   if(%deplObj.getTarget() != -1)
      setTargetSensorGroup(%deplObj.getTarget(), %plyr.client.team);
   if(%deplObj2.getTarget() != -1)
      setTargetSensorGroup(%deplObj2.getTarget(), %plyr.client.team);
   if(%deplObj3.getTarget() != -1)
      setTargetSensorGroup(%deplObj3.getTarget(), %plyr.client.team);
   if(%deplObj4.getTarget() != -1)
      setTargetSensorGroup(%deplObj4.getTarget(), %plyr.client.team);
   if(%deplObj5.getTarget() != -1)
      setTargetSensorGroup(%deplObj5.getTarget(), %plyr.client.team);
   if(%deplObj6.getTarget() != -1)
      setTargetSensorGroup(%deplObj6.getTarget(), %plyr.client.team);
   if(%deplObj7.getTarget() != -1)
      setTargetSensorGroup(%deplObj7.getTarget(), %plyr.client.team);
   if(%deplObj.field.getTarget() != -1)
      setTargetSensorGroup(%deplObj.field.getTarget(), %plyr.client.team);

   // place the deployable in the MissionCleanup/Deployables group (AI reasons)
   addToDeployGroup(%deplObj);
   addToDeployGroup(%deplObj2);
   addToDeployGroup(%deplObj3);
   addToDeployGroup(%deplObj4);
   addToDeployGroup(%deplObj5);
   addToDeployGroup(%deplObj6);
   addToDeployGroup(%deplObj7);

   //let the AI know as well...
   AIDeployObject(%plyr.client, %deplObj);
   AIDeployObject(%plyr.client, %deplObj2);
   AIDeployObject(%plyr.client, %deplObj3);
   AIDeployObject(%plyr.client, %deplObj4);
   AIDeployObject(%plyr.client, %deplObj5);
   AIDeployObject(%plyr.client, %deplObj6);
   AIDeployObject(%plyr.client, %deplObj7);

   //Associate all the bunker parts together for damage/repair purposes.
   %deplObj.mainbunker = 1;
   %deplObj2.mainbunker = 0;
   %deplObj3.mainbunker = 0;
   %deplObj4.mainbunker = 0;
   %deplObj5.mainbunker = 0;
   %deplObj6.mainbunker = 0;
   %deplObj.right = %deplObj2;
   %deplObj.left = %deplObj3;
   %deplObj.top = %deplObj4;
   %deplObj.bottom = %deplObj5;
   %deplObj.baseturret = %deplObj6;
   %deplObj.inventoryst = %deplObj7;
   %deplObj2.parentbunker = %deplObj;
   %deplObj3.parentbunker = %deplObj;
   %deplObj4.parentbunker = %deplObj;
   %deplObj5.parentbunker = %deplObj;
   %deplObj6.parentbunker = %deplObj;

   // play the deploy sound
   serverPlay3D(%item.deploySound, %deplObj.getTransform());

   // increment the team count for this deployed object

   $TeamDeployedCount[%plyr.team, %item.item]++;

   %deplObj.deploy();

 echo (%deplObj);
   return %deplObj;
}

function BunkerForceField::onAdd(%data, %obj)
{
   Parent::onAdd(%data, %obj);
   for (%i=0; %i < PZones.getCount(); %i++)
   {
      if (PZones.getObject(%i).ffield == %obj)
         %obj.pzone = PZones.getObject(%i);
   }
}

function DeployedBunker::onDestroyed(%this, %obj, %prevState)
{
   Parent::onDestroyed(%this, %obj, %prevState);
   $TeamDeployedCount[%obj.team, BunkerDeployable]--;
   %obj.right.schedule(500, "delete");
   %obj.left.schedule(500, "delete");
   %obj.top.schedule(500, "delete");
   %obj.bottom.schedule(500, "delete");
   %obj.field.pzone.schedule(490, "delete");
   %obj.field.schedule(500, "delete");
   %obj.baseturret.schedule(500, "delete");
   %obj.inventoryst.trigger.schedule(490, "delete");
   %obj.inventoryst.schedule(500, "delete");
   %obj.schedule(510, "delete");
}

function DeployedBunker2::onDestroyed(%this, %obj, %prevState)
{
   Parent::onDestroyed(%this, %obj, %prevState);
   $TeamDeployedCount[%obj.team, BunkerDeployable]--;
   %obj2 = %obj.parentbunker;
   %obj2.right.schedule(500, "delete");
   %obj2.left.schedule(500, "delete");
   %obj2.top.schedule(500, "delete");
   %obj2.bottom.schedule(500, "delete");
   %obj2.field.pzone.schedule(490, "delete");
   %obj2.field.schedule(500, "delete");
   %obj2.baseturret.schedule(500, "delete");
   %obj2.inventoryst.trigger.schedule(490, "delete");
   %obj2.inventoryst.schedule(500, "delete");
   %obj2.schedule(510, "delete");
}

function BunkerDeployableImage::testObjectTooClose(%item)
{
   %mask =    ($TypeMasks::VehicleObjectType     | $TypeMasks::MoveableObjectType   |
               $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType |
               $TypeMasks::ItemObjectType        | $TypeMasks::TurretObjectType     |
               $TypeMasks::InteriorObjectType);
   InitContainerRadiusSearch( %item.surfacePt, 20, %mask );
   %test = containerSearchNext();
   if(!%test)
   {
      InitContainerRadiusSearch( %item.surfacePt, 20, $TypeMasks::PlayerObjectType );
      %test = containerSearchNext();
      if (%test)
         %test = containerSearchNext();
   }
   return %test;
}

function BunkerDeployableImage::testNoTerrainFound(%item)
{
   return %item.surface.getClassName() !$= TerrainBlock;
}

function calcBunkerInWay(%position, %targetObject)
{
   %mask = $TypeMasks::StaticObjectType;
   %found = containerRayCast(%position, posFromTransform(%targetObject.getTransform()), %mask);
   if (%found)
   {
      if ((%found.getClassName() $= InteriorInstance) || (%found.getClassName() $= TerrainBlock) || (%found.getClassName() $= TSStatic))
         return 1;
      if (%found == %targetObject)
         return 1;
      if (%found.getDataBlock().className $= "Bunker" || %found.getDataBlock().className $= "Wall")
         return 0;
      else
      {
         %found = containerRayCast(%position, posFromTransform(%targetObject.getTransform()), %mask, %found);
         if (%found)
         {
            if ((%found.getClassName() $= InteriorInstance) || (%found.getClassName() $= TerrainBlock) || (%found.getClassName() $= TSStatic))
               return 1;
            if (%found == %targetObject)
               return 1;
            if (%found.getDataBlock().className $= "Bunker" || %found.getDataBlock().className $= "Wall")
               return 0;
         }
      }
   }
   return 1;
}