
//---------------------------------------------------------
// Deployable wall
//---------------------------------------------------------

$TeamDeployableMax[WallDeployable] = 15;
$TeamDeployableMin[WallDeployable] = 15;

//explosion data////////////////////////////
////////////////////////////////////////////
datablock ParticleData(BwallExplosionSmoke)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = -0.30;   // rises slowly
   inheritedVelFactor   = 0.025;

   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 500;

   textureName          = "particleTest";

   useInvAlpha =  true;
   spinRandomMin = -100.0;
   spinRandomMax =  100.0;

   textureName = "special/Smoke/bigSmoke";

   colors[0]     = "0.4 0.4 0.4 0.5";
   colors[1]     = "0.3 0.3 0.3 0.5";
   colors[2]     = "0.25 0.25 0.25 0.0";
   colors[3]     = "0.1 0.1 0.1 0.0";
   sizes[0]      = 5.0;
   sizes[1]      = 6.0;
   sizes[2]      = 10.0;
   sizes[3]      = 12.0;
   times[0]      = 0.0;
   times[1]      = 0.333;
   times[2]      = 0.666;
   times[3]      = 1.0;



};

datablock ParticleEmitterData(BwallExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 8.0;


   ejectionVelocity = 1.25;
   velocityVariance = 1.2;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "BwallExplosionSmoke";

};

datablock ExplosionData(BwallSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 100;

   offset = 4.0;

   playSpeed = 1.5;

   sizes[0] = "2.0 2.0 2.0";
   sizes[1] = "2.0 2.0 2.0";
   times[0] = 0.0;
   times[1] = 1.0;

};             

datablock ExplosionData(BwallSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 50;

   offset = 4.0;

   playSpeed = 1.0;

   sizes[0] = "2.0 2.0 2.0";
   sizes[1] = "2.0 2.0 2.0";
   times[0] = 0.0;
   times[1] = 1.0;
};
datablock ExplosionData(BwallExplosion)
{
   soundProfile   = GrenadeExplosionSound;

   subExplosion[0] = BwallSubExplosion1;
   subExplosion[1] = BwallSubExplosion2;

   emitter[0] = BwallExplosionSmokeEmitter;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};


datablock StaticShapeData(Deployedwall) : StaticShapeDamageProfile
{
className = Wall;
shapeFile = "Pmiscf.dts"; // dmiscf.dts, alternate
maxDamage = 4.0;//was5.0 v2.0-RED
destroyedLevel = 4.0;
disabledLevel = 4.0;

explosion = BwallExplosion;
expDmgRadius = 1.0;
expDamage = 0.1;
expImpulse = 1500.0;

dynamicType = $TypeMasks::StaticShapeObjectType;
deployedObject = true;
cmdCategory = "DSupport";
cmdIcon = CMDSensorIcon;
cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
targetNameTag = 'Blast Wall';
deployAmbientThread = true;
debrisShapeName = "debris_generic_small.dts";
debris = DeployableDebris;
heatSignature = 0;
};

datablock ShapeBaseImageData(wallDeployableImage)
{
mass = 20;
emap = true;
shapeFile = "Stackable1s.dts";
item = wallDeployable;
mountPoint = 1;
offset = "0 0 0";
deployed = Deployedwall;
heatSignature = 0;

stateName[0] = "Idle";
stateTransitionOnTriggerDown[0] = "Activate";

stateName[1] = "Activate";
stateScript[1] = "onActivate";
stateTransitionOnTriggerUp[1] = "Idle";

isLarge = true;
maxDepSlope = 360; // 30
deploySound = ItemPickupSound;

minDeployDis = 0.5;
maxDeployDis = 5.0;
};

datablock ItemData(wallDeployable)
{
className = Pack;
catagory = "Deployables";
shapeFile = "Stackable1s.dts";
mass = 5.0;
elasticity = 0.2;
friction = 0.6;
pickupRadius = 1;
rotate = true;
image = "wallDeployableImage";
pickUpName = "a blast wall";
heatSignature = 0;
emap = true;
};

function wallDeployableImage::testObjectTooClose(%item)
{
%mask = $TypeMasks::PlayerObjectType;
%pos = %item.surfacePt;
return !ContainerBoxEmpty (%mask, %pos, $MinDeployableDistance);
}

function wallDeployableImage::testNoTerrainFound(%item)
{
//don't check this for non-Landspike turret deployables
}

function wallDeployable::onPickup(%this, %obj, %shape, %amount)
{
// created to prevent console errors
}

function Deployedwall::onDestroyed(%this, %obj, %prevState)
{
Parent::onDestroyed(%this, %obj, %prevState);
$TeamDeployedCount[%obj.team, wallDeployable]--;
%obj.schedule(500, "delete");
}

function wallcheckclear(%obj)
{
   %obj.setTransform(%obj.initTransform);
}