//element shield pack, when mounted protects user from ground impact lightning and lava damage.
//------------------------------------------------------------------------------

datablock AudioProfile(ElementShieldPackActivateSound)
{
filename = "fx/packs/shield_on.wav";
description = ClosestLooping3d;
preload = true;
};

datablock ShapeBaseImageData(ElementShieldPackImage)
{
shapeFile = "pack_upgrade_shield.dts";
item = ElementShieldPack;
mountPoint = 1;
offset = "0 0 0";

usesEnergy = false;
minEnergy = 3;

stateName[0] = "default";
stateSequence[0] = "activation";

};

datablock ItemData(ElementShieldPack)
{
className = Pack;
catagory = "Packs";
shapeFile = "pack_upgrade_shield.dts";
mass = 1;
elasticity = 0.2;
friction = 0.6;
pickupRadius = 2;
rotate = true;
image = "ElementShieldPackImage";
pickUpName = "an element shield pack";

computeCRC = true;
};

function ElementShieldPackImage::onMount(%data, %obj, %node)
{
messageClient(%obj.client, 'MsgElementShieldPackOn', '\c2you are guarded from ground,impact,lava, and lightning damage.');
%obj.antiElement = true; //Variable for antienergy pack
Parent::onMount(%this,%obj,%slot);
CommandToClient(%obj.client, 'CenterPrint', "Element Shield Pack - protects user from falling,impact,lava, and lightning damage. active when mounted.", 4, 2 );
}

function ElementShieldPackImage::onUnmount(%data, %obj, %node)
{
messageClient(%obj.client, 'MsgElementShieldPackOff', '\c2element shield pack off.');
%obj.setImageTrigger(%node, false);
%obj.antiElement = ""; 
}

function ElementShieldPack::onPickup(%this, %obj, %shape, %amount)
{
// created to prevent console errors
}