//--------------------------------------
// Green Lantern- anti gravity proj gun, RED added in version 2.0
//--------------------------------------


//--------------------------------------------------------------------------
// Sounds
//--------------------------------------
datablock AudioProfile(GreenLanternSwitchSound)
{
   filename    = "fx/weapons/grenadelauncher_reload.wav";
   description = AudioClosest3d;
   preload = true;
   effect = PlasmaSwitchEffect;
};

datablock AudioProfile(GreenLanternFireSound)
{
   filename    = "fx/vehicles/shrike_blaster_projectile.wav";
   description = AudioDefault3d;
   preload = true;
   effect = PlasmaFireEffect;
};


datablock AudioProfile(GreenLanternReloadSound)
{
   filename    = "fx/weapons/chaingun_start.wav";
   description = Audioclosest3d;
   preload = true;
   effect = PlasmaReloadEffect;
};

datablock AudioProfile(GreenLanternExplosionSound)
{
   filename    = "fx/explosions/vehicle_explosion.wav";
   description = AudioBIGExplosion3d;
   preload = true;
   effect = MortarExplosionEffect;
};

datablock AudioProfile(PlasmaFireWetSound)
{
   filename    = "fx/weapons/plasma_fizzle.wav";
   description = AudioClose3d;
   preload = true;
};
///////////////////////////////
//explosion stuff//////////////
///////////////////////////////

datablock ParticleData( LanternCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 1.0;
   lifetimeMS           = 3000;
   lifetimeVarianceMS   = 0;
   textureName          = "special/crescent3";
   colors[0] = "0.9 0.0 0.0 1.0";
   colors[1] = "0.9 0.0 0.0 0.5";
   colors[2] = "0.9 0.0 0.0 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 2.5;
   sizes[2]      = 3.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( LanternCrescentEmitter )
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 50;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 360;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "LanternCrescentParticle";
};

datablock ParticleData( Lantern2CrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 1.0;
   lifetimeMS           = 3000;
   lifetimeVarianceMS   = 0;
   textureName          = "special/crescent3";
   colors[0] = "0.9 0.0 0.2 1.0";
   colors[1] = "0.9 0.0 0.2 0.5";
   colors[2] = "0.9 0.0 0.2 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 2.5;
   sizes[2]      = 3.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( Lantern2CrescentEmitter )
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 40;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 360;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "Lantern2CrescentParticle";
};

datablock ParticleData(LanternSmokeRing)
{
   dragCoefficient      = 1.0;
   gravityCoefficient   = -0.01;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 100;
   useInvAlpha = true;
   textureName          = "special/Smoke/bigSmoke";
   colors[0]     = "0.7 1.0 0.7 0.5";
   colors[1]     = "0.3 0.7 0.3 0.8";
   colors[2]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 15;
   sizes[1]      = 23;
   sizes[2]      = 30;
   times[0]      = 0.0;
   times[1]      = 0.7;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(LanternSmokeRingEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 50.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 85;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   lifetimeMS       = 750;
   particles = "LanternSmokeRing";
};
//----------------------------------------------------------------------------
// Debris
//----------------------------------------------------------------------------

datablock ParticleData( LanternDebrisParticle )
{
   dragCoeffiecient     = 1.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;

   lifetimeMS           = 1000;  
   lifetimeVarianceMS   = 100;

   textureName          = "special/Smoke/bigSmoke";

   useInvAlpha =     true;

   spinRandomMin = -60.0;
   spinRandomMax = 60.0;

   colors[0]     = "0.7 1.0 0.7 0.5";
   colors[1]     = "0.3 0.7 0.3 0.8";
   colors[2]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 0.0;
   sizes[1]      = 1.0;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( LanternDebrisEmitter )
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 1;

   ejectionVelocity = 1.0;  // A little oomph at the back end
   velocityVariance = 0.2;

   thetaMin         = 0.0;
   thetaMax         = 40.0;

   particles = "LanternDebrisParticle";
};

datablock DebrisData( LanternDebris )
{
   emitters[0] = LanternDebrisEmitter;

   explosion = LanternDebrisExplosion;
   explodeOnMaxBounce = true;

   elasticity = 0.4;
   friction = 0.2;

   lifetime = 5;
   lifetimeVariance = 0.0;

   numBounces = 1;
};             

datablock ParticleData(LanternDebrisSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 0;
   textureName          = "special/spark00";
   colors[0]     = "0.0 0.9 0.0 1.0";
   colors[1]     = "0.0 0.9 0.0 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 0.6;
   sizes[1]      = 0.2;
   sizes[2]      = 0.05;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(LanternDebrisSparkEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 50;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "LanternDebrisSparks";
};

datablock ExplosionData(LanternDebrisExplosion)
{
   soundProfile   = GrenadeThrowSound;

   emitter[0] = LanternDebrisSparkEmitter;

   faceViewer           = false;
};

datablock ExplosionData(GreenLanternSubExplosion1)
{
   explosionShape = "mortar_explosion.dts";
   faceViewer           = true;

   emitter[0]     = LanternCrescentEmitter;
   emitter[1]     = Lantern2CrescentEmitter;

   delayMS = 100;

   offset = 0.0;

   playSpeed = 1.5;

   sizes[0] = "1.5 1.5 1.5";
   sizes[1] = "1.5 1.5 1.5";
   times[0] = 0.0;
   times[1] = 1.0;

};             

datablock ExplosionData(GreenLanternSubExplosion2)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;

   emitter[0]     = LanternCrescentEmitter;
   emitter[1]     = Lantern2CrescentEmitter;

   delayMS = 50;

   offset = 0.0;

   playSpeed = 1.0;

   sizes[0] = "3.0 3.0 3.0";
   sizes[1] = "3.0 3.0 3.0";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(GreenLanternSubExplosion3)
{
   explosionShape = "mortar_explosion.dts";
   faceViewer           = true;

   emitter[0]     = LanternCrescentEmitter;
   emitter[1]     = Lantern2CrescentEmitter;

   delayMS = 0;
   offset = 0.0;
   playSpeed = 0.7;

   sizes[0] = "4.0 4.0 4.0";
   sizes[1] = "4.0 4.0 4.0";
   times[0] = 0.0;
   times[1] = 1.0;

};


datablock ExplosionData(GreenLanternExplosion)
{
   soundProfile   = GreenLanternExplosionSound;

   emitter[0]     = LanternSmokeRingEmitter;

   debris = LanternDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 360;
   debrisNum = 15;
   debrisVelocity = 40.0;
   debrisVelocityVariance = 3.0;

   subExplosion[0] = GreenLanternSubExplosion1;
   subExplosion[1] = GreenLanternSubExplosion2;
   subExplosion[2] = GreenLanternSubExplosion3;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 40.0;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearFlareProjectileData(GreenLanternBolt)
{
   doDynamicClientHits = true;
   projectileShapeName = "turret_muzzlepoint.dts";
   hasDamageRadius     = true;
   indirectDamage      = 1.0;
   damageRadius        = 45.0;
   kickBackStrength    = 3000;
   radiusDamageType    = $DamageType::Lantern;
   explosion           = GreenLanternExplosion;
   underwaterExplosion = "UnderwaterMortarExplosion";
   splash              = PlasmaSplash;

   sound	     = PlasmaProjectileSound;

   dryVelocity       = 0.0;
   wetVelocity       = 0.0;
   velInheritFactor  = 0.0;
   fizzleTimeMS      = 6000;
   lifetimeMS        = 6000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 6000;

   activateDelayMS = 100;

   scale             = "0.1 0.1 0.1";
   numFlares         = 60;
   flareColor        = "0.0 0.9 0.2";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

   hasLight    = true;
   lightRadius = 15;
   lightColor  = "0.0 0.9 0.2";
};


//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(GreenLanternAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_grenade.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some Green Lantern ammo";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(GreenLantern)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "turret_elf_large.dts";
   image = GreenLanternImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a Green Lantern";
};

datablock ShapeBaseImageData(GreenLanternImage)
{
   className = WeaponImage;
   shapeFile = "turret_elf_large.dts";
   item = GreenLantern;
   ammo = GreenLanternAmmo;
   offset = "0 0 0";
   emap = true;

   projectile = GreenLanternBolt;
   projectileType = LinearFlareProjectile;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSequence[1]                 = "Activated";
   stateSound[1]                    = GreenLanternSwitchSound;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 1.5;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3]                    = GreenLanternFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.5; 
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSound[4]                    = GreenLanternReloadSound;

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = DiscDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

