// ------------------------------------------------------------------------
//  boost grenade (thrown by hand) script -RED added in V2.0
// ------------------------------------------------------------------------

datablock AudioProfile(BoostGrenadeExplosionSound)
{
   filename = "fx/weapons/spinfusor_impact_UW.wav";
   description = AudioBIGExplosion3d;
   preload = true;
   effect = SatchelChargeExplosionEffect;
};

//--------------------------------------------------------------------------
// Sparks
//--------------------------------------------------------------------------
datablock ParticleData(BoostGrenadeSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;
   textureName          = "special/bigSpark";
   colors[0]     = "0.9 0.9 0.0 1.0";
   colors[1]     = "0.9 0.9 0.0 1.0";
   colors[2]     = "0.3 0.3 0.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(BoostGrenadeSparkEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 12;
   velocityVariance = 6.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "BoostGrenadeSparks";
};

datablock ParticleData( BoostGrenadeCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0] = "0.0 0.0 0.9 1.0";
   colors[1] = "0.0 0.0 0.9 0.5";
   colors[2] = "0.0 0.0 0.9 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 4.0;
   sizes[2]      = 5.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( BoostGrenadeCrescentEmitter )
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "BoostGrenadeCrescentParticle";
};

datablock ParticleData( BoostGrenade2CrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0] = "0.8 0.8 0.0 1.0";
   colors[1] = "0.8 0.8 0.0 0.5";
   colors[2] = "0.3 0.3 0.0 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 4.0;
   sizes[2]      = 5.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( BoostGrenade2CrescentEmitter )
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "BoostGrenade2CrescentParticle";
};
//--------------------------------------------------------------------------
// Shockwave
//--------------------------------------------------------------------------
datablock ShockwaveData(BoostGrenadeShockwave)
{
   width = 6.0;
   numSegments = 20;
   numVertSegments = 2;
   velocity = 5;
   acceleration = 10.0;
   lifetimeMS = 1000;
   height = 1.0;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.9 0.9 0.0 1.0";
   colors[1] = "0.1 0.1 0.8 0.5";
   colors[2] = "0.0 0.3 0.8 0.0";

   mapToTerrain = false;
   orientToNormal = true;
   renderBottom = false;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------------------------------------------
datablock ExplosionData(BoostGrenadeExplosion)
{
   soundProfile   = BoostGrenadeExplosionSound;
   shockwave =  BoostGrenadeShockwave;

   emitter[0] = BoostGrenadeSparkEmitter;
   emitter[1] = BoostGrenadeCrescentEmitter;
   emitter[2] = BoostGrenade2CrescentEmitter;

   shakeCamera = false;
   camShakeFreq = "4.0 5.0 4.5";
   camShakeAmp = "140.0 140.0 140.0";
   camShakeDuration = 1.0;
   camShakeRadius = 15.0;
};

//--------------------
//Boost Grenade thrown
//--------------------

datablock ItemData(BoostGrenadeThrown)
{
	className = Weapon;
	shapeFile = "grenade.dts";
	mass = 0.7;
	elasticity = 0.2;
   friction = 1;
   pickupRadius = 2;
   maxDamage = 0.5;
	explosion = BoostGrenadeExplosion;
	underwaterExplosion = UnderwaterGrenadeExplosion;
   damageRadius        = 20.0;
   radiusDamageType    = $DamageType::Grenade;
   kickBackStrength    = 7000;
   
   computeCRC = true;
   sticky = true;

};

datablock ItemData(BoostGrenade)
{
	className = HandInventory;
	catagory = "Handheld";
	shapeFile = "grenade.dts";
	mass = 0.7;
	elasticity = 0.2;
   friction = 1;
   pickupRadius = 2;
   thrownItem = BoostGrenadeThrown;
	pickUpName = "some Boost Grenades";
	isGrenade = true;

   computeCRC = true;

};

function BoostGrenadeThrown::onThrow(%this, %gren, %obj)
{
AIGrenadeThrown(%gren);
%gren.detThread = schedule(400, %gren, "detonateGrenade", %gren);
}
