//Widow Maker
//-----------------------------------------------------
//Sounds
//----------------------------------------

datablock AudioProfile(chargingDelaySound)
{
   filename    = "fx/Bonuses/down_passback2_moyoyo.WAV";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(WidowMakerSwitchSound)
{
   filename    = "fx/powered/turret_heavy_reload.wav";
   description = AudioClosest3d;
   preload = true;
   effect = MortarSwitchEffect;
};

datablock AudioProfile(WidowMakerFireSound)
{
   filename    = "fx/powered/turret_mortar_fire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = MortarFireEffect;
};

datablock AudioProfile(WidowMakerProjectileSound)
{
   filename    = "fx/vehicles/htransport_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(WidowMakerExplosionSound)
{
   filename    = "fx/vehicles/bomber_bomb_impact.wav";
   description = AudioBIGExplosion3d;
   preload = true;
   effect = MortarExplosionEffect;
};

//--------------------------------------------------------------------------
// Shockwave
//--------------------------------------------------------------------------
datablock ShockwaveData(WidowMakerShockwave)
{
   width = 24.0;
   numSegments = 64;
   numVertSegments = 6;
   velocity = 30;
   acceleration = 30.0;
   lifetimeMS = 4500;
   height = 12.0;
   verticalCurve = 0.5;
   is2D = false;
   
   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0]     = "1.0 0.75 0.2 1.0";
   colors[1]     = "1.0 0.75 0.2 1.0";
   colors[2]     = "1.0 0.75 0.2 0.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};

//--------------------------------------------------------------------------
// Shockwave2
//--------------------------------------------------------------------------
datablock ShockwaveData(WidowMakerShockwave2)
{
   width = 60.0;
   numSegments = 64;
   numVertSegments = 6;
   velocity = 40;
   acceleration = 40.0;
   lifetimeMS = 4500;
   height = 2.0;
   verticalCurve = 0.5;
   is2D = false;
   
   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0]     = "1.0 0.75 0.2 1.0";
   colors[1]     = "1.0 0.75 0.2 1.0";
   colors[2]     = "1.0 0.75 0.2 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = true;
};


//-----------------------------------------------
//Explosion Particle Effects
//-----------------------------------------------

datablock ParticleData( WidowMakerCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 1600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "1.0 0.75 0.2 1.0";
   colors[1]     = "1.0 0.75 0.2 1.0";
   colors[2]     = "1.0 0.75 0.2 1.0";
   sizes[0]      = 4.0;
   sizes[1]      = 8.0;
   sizes[2]      = 9.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( WidowMakerCrescentEmitter )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 40;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "WidowMakerCrescentParticle";
};

datablock ParticleData(WidowMakerExplosionSmoke)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = 0.09;   // rises slowly
   inheritedVelFactor   = 0.025;

   lifetimeMS           = 4000;
   lifetimeVarianceMS   = 500;

   textureName          = "particleTest";

   useInvAlpha =  true;
   spinRandomMin = -100.0;
   spinRandomMax =  100.0;

   textureName = "special/Smoke/bigSmoke";

   colors[0]     = "0.1 0.1 0.1 1.0";
   colors[1]     = "0.1 0.1 0.1 0.75";
   colors[2]     = "0.1 0.1 0.1 0.5";
   colors[3]     = "0.1 0.1 0.1 0.0";
   sizes[0]      = 60.0;
   sizes[1]      = 73.0;
   sizes[2]      = 120.0;
   sizes[3]      = 144.0;
   times[0]      = 0.0;
   times[1]      = 0.333;
   times[2]      = 0.666;
   times[3]      = 1.0;



};

datablock ParticleEmitterData(WidowMakerExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 0.0;


   ejectionVelocity = 50.0;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "WidowMakerExplosionSmoke";

};

datablock ParticleEmitterData(WidowMaker2ExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 0.0;


   ejectionVelocity = 40.0;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "WidowMakerExplosionSmoke";

};

datablock ParticleEmitterData(WidowMaker3ExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 0.0;


   ejectionVelocity = 60.0;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "WidowMakerExplosionSmoke";

};

datablock ParticleData(WidowMakerSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 2500;
   lifetimeVarianceMS   = 150;
   textureName          = "special/bigSpark";
   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "1.0 0.36 0.26 0.0";
   sizes[0]      = 10.5;
   sizes[1]      = 10.5;
   sizes[2]      = 20.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(WidowMakerSparksEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 50;
   velocityVariance = 25.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "WidowMakerSparks";
};

//---------------------------------------------------------------------------
// Explosion
//---------------------------------------------------------------------------

datablock ExplosionData(WidowMakerSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 100;

   offset = "0 0 0";

   playSpeed = 0.40;

   sizes[0] = "20.0 20.0 20.0";
   sizes[1] = "20.0 20.0 20.0";
   times[0] = 0.0;
   times[1] = 1.0;

};             

datablock ExplosionData(WidowMakerSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;
   delayMS = 50;
   offset = "0 50 0";
   playSpeed = 0.30;

   sizes[0] = "40.0 40.0 40.0";
   sizes[1] = "40.0 40.0 40.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(WidowMakerSubExplosion3)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 0;

   offset = "0 100 0";

   playSpeed = 0.20;

   sizes[0] = "40.0 40.0 40.0";
   sizes[1] = "70.0 70.0 70.0";
   times[0] = 0.0;
   times[1] = 1.0;

};                          

datablock ExplosionData(WidowMakerExplosion)
{
   soundProfile   = WidowMakerExplosionSound;

   shockwave = WidowMakerShockwave;
   shockwaveOnTerrain = true;    

   subExplosion[0] = WidowMakerSubExplosion1;
   subExplosion[1] = WidowMakerSubExplosion2;
   subExplosion[2] = WidowMakerSubExplosion3;

   emitter[0] = WidowMakerCrescentEmitter;
   emitter[1] = WidowMakerSparksEmitter;
   emitter[2] = BottomSmokeRingEmitter;
   //emitter[3] = WidowMaker2ExplosionSmokeEmitter;
   //emitter[4] = WidowMaker3ExplosionSmokeEmitter;
      
   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};

//--------------------------------
//mushroom top
//--------------------------------

//--------------------------------------------------------------
// DEBRIS FIRE PARTICLES commented out in v1.9 too laggy-RED
//--------------------------------------------------------------
//
//datablock ParticleData(NukeDebrisFireParticle)
//{
//   dragCoeffiecient     = 0.0;
//   gravityCoefficient   = -0.2;
//   inheritedVelFactor   = 0.0;
//
//   lifetimeMS           = 350;
//   lifetimeVarianceMS   = 0;
//
//   textureName          = "particleTest";
//
//   useInvAlpha = false;
//   spinRandomMin = -160.0;
//   spinRandomMax = 160.0;
//
//   animateTexture = true;
//   framesPerSec = 15;
//
//
//   animTexName[0]       = "special/Explosion/exp_0016";
//   animTexName[1]       = "special/Explosion/exp_0018";
//   animTexName[2]       = "special/Explosion/exp_0020";
//   animTexName[3]       = "special/Explosion/exp_0022";
//   animTexName[4]       = "special/Explosion/exp_0024";
//   animTexName[5]       = "special/Explosion/exp_0026";
//   animTexName[6]       = "special/Explosion/exp_0028";
//   animTexName[7]       = "special/Explosion/exp_0030";
//   animTexName[8]       = "special/Explosion/exp_0032";
//
//   colors[0]     = "1.0 0.7 0.5 1.0";
//   colors[1]     = "1.0 0.5 0.2 1.0";
//   colors[2]     = "1.0 0.25 0.1 0.0";
//   sizes[0]      = 1.5;
//   sizes[1]      = 6.0;
//   sizes[2]      = 3.0;
//   times[0]      = 0.0;
//   times[1]      = 0.2;
//   times[2]      = 1.0;
//};
//
//datablock ParticleEmitterData(NukeDebrisFireEmitter)
//{
//   ejectionPeriodMS = 20;
//   periodVarianceMS = 1;
//
//   ejectionVelocity = 0.25;
//   velocityVariance = 0.0;
//
//   thetaMin         = 0.0;
//   thetaMax         = 30.0;
//
//   particles = "NukeDebrisFireParticle";
//};

//--------------------------------------------------------------
// DEBRIS SMOKE PARTICLES commented out in v1.9 too laggy -RED
//--------------------------------------------------------------


//datablock ParticleData( NukeDebrisSmokeParticle )
//{
//   dragCoeffiecient     = 4.0;
//   gravityCoefficient   = -0.00;   // rises slowly
//   inheritedVelFactor   = 0.2;
//
//  lifetimeMS           = 1000;  
//   lifetimeVarianceMS   = 100;   // ...more or less
//
//  textureName          = "particleTest";
//
//   useInvAlpha =     true;
//
//   spinRandomMin = -50.0;
//   spinRandomMax = 50.0;
//
//   colors[0]     = "0.1 0.1 0.1 0.0";
//   colors[1]     = "0.1 0.1 0.1 1.0";
//   colors[2]     = "0.1 0.1 0.1 0.0";
//   sizes[0]      = 9;
//   sizes[1]      = 13.5;
//   sizes[2]      = 22.5;
//   times[0]      = 0.0;
//   times[1]      = 0.7;
//   times[2]      = 1.0;
//};
//
//datablock ParticleEmitterData( NukeDebrisSmokeEmitter )
//{
//  ejectionPeriodMS = 25;
//   periodVarianceMS = 5;
//
//   ejectionVelocity = 1.0;  // A little oomph at the back end
//   velocityVariance = 0.5;
//
//   thetaMin         = 10.0;
//   thetaMax         = 30.0;
//
//   useEmitterSizes = true;
//
//   particles = "NukeDebrisSmokeParticle";
//};
//
//
//datablock ExplosionData(NukeDebrisExplosion)
//{
//   explosionShape = "effect_plasma_explosion.dts";
//   soundProfile = plasmaExpSound;
//   faceViewer = true;
//   explosionScale = "0.4 0.4 0.4";
//};
//
//datablock DebrisData( NukeFireballDebris )
//{
//   emitters[0] = NukeDebrisSmokeEmitter;
//   emitters[1] = NukeDebrisFireEmitter;
//
//   explosion = NukeDebrisExplosion;
//   explodeOnMaxBounce = true;
//
//   elasticity = 0.4;
//   friction = 0.2;
//
//   lifetime = 100.0;
//   lifetimeVariance = 30.0;
//
//   numBounces = 0;
//   bounceVariance = 0;
//};  

datablock ExplosionData(WidowMakerTopSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   //debris = NukeFireballDebris;
   //debrisThetaMin = 10;
   //debrisThetaMax = 80;
   //debrisNum = 6;
   //debrisNumVariance = 1;
   //debrisVelocity = 20.0;
   //debrisVelocityVariance = 5.0;

   delayMS = 100;

   offset = "0 0 0";

   playSpeed = 0.40;

   sizes[0] = "20.0 20.0 20.0";
   sizes[1] = "20.0 20.0 20.0";
   times[0] = 0.0;
   times[1] = 1.0;

};             

datablock ExplosionData(WidowMakerTopSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   //debris = NukeFireballDebris;
   //debrisThetaMin = 10;
   //debrisThetaMax = 80;
   //debrisNum = 6;
   //debrisNumVariance = 1;
   //debrisVelocity = 20.0;
   //debrisVelocityVariance = 5.0;

   delayMS = 50;
   offset = "0 50 0";
   playSpeed = 0.30;

   sizes[0] = "40.0 40.0 40.0";
   sizes[1] = "40.0 40.0 40.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(WidowMakerTopSubExplosion3)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   //debris = NukeFireballDebris;
   //debrisThetaMin = 10;
   //debrisThetaMax = 80;
   //debrisNum = 6;
   //debrisNumVariance = 1;
   //debrisVelocity = 20.0;
   //debrisVelocityVariance = 5.0;

   delayMS = 0;

   offset = "0 100 0";

   playSpeed = 0.20;

   sizes[0] = "40.0 40.0 40.0";
   sizes[1] = "70.0 70.0 70.0";
   times[0] = 0.0;
   times[1] = 1.0;

};                          

datablock ExplosionData(WidowMakerTopExplosion)
{
   soundProfile   = WidowMakerExplosionSound;

   shockwave = WidowMakerShockwave2;
   shockwaveOnTerrain = false;    

   subExplosion[0] = WidowMakerTopSubExplosion1;
   subExplosion[1] = WidowMakerTopSubExplosion2;
   subExplosion[2] = WidowMakerTopSubExplosion3;
      
   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};

//---------------------------------------------------------------------------
//Middle Explosion
//---------------------------------------------------------------------------
datablock ParticleData(SmokeRing)
{
   dragCoefficient      = 1.0;
   gravityCoefficient   = -0.01;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 100;
   useInvAlpha = true;
   textureName          = "particleTest";
   colors[0]     = "0.6 0.6 0.6 1.0";
   colors[1]     = "0.5 0.5 0.5 1.0";
   colors[2]     = "0.3 0.3 0.3 0.0";
   sizes[0]      = 15;
   sizes[1]      = 23;
   sizes[2]      = 30;
   times[0]      = 0.0;
   times[1]      = 0.7;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(SmokeRingEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 50.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 85;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   lifetimeMS       = 750;
   particles = "SmokeRing";
};


datablock ExplosionData(MiddleSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 100;

   offset = 0.0;

   playSpeed = 0.40;

   sizes[0] = "10.0 10.0 10.0";
   sizes[1] = "10.0 10.0 10.0";
   times[0] = 0.0;
   times[1] = 1.0;

};             

datablock ExplosionData(MiddleSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;
   delayMS = 50;
   offset = 0.0;
   playSpeed = 0.30;

   sizes[0] = "10.0 10.0 10.0";
   sizes[1] = "10.0 10.0 10.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(MiddleSubExplosion3)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 0;

   offset = 0.0;

   playSpeed = 0.20;

   sizes[0] = "10.0 10.0 10.0";
   sizes[1] = "10.0 10.0 10.0";
   times[0] = 0.0;
   times[1] = 1.0;

};                          

datablock ExplosionData(MiddleExplosion)
{
   soundProfile   = WidowMakerExplosionSound;

   emitter[0] = SmokeRingEmitter;
   
   subExplosion[0] = MiddleSubExplosion1;
   subExplosion[1] = MiddleSubExplosion2;
   subExplosion[2] = MiddleSubExplosion3;
     
   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};

//---------------------------------------------------------------------------
// Smoke particles
//---------------------------------------------------------------------------

datablock ParticleData(WidowMakerSmokeParticle)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = -0.3;   // rises slowly
   inheritedVelFactor   = 0.125;

   lifetimeMS           =  1200;
   lifetimeVarianceMS   =  200;
   useInvAlpha          =  true;
   spinRandomMin        = -100.0;
   spinRandomMax        =  100.0;

   animateTexture = false;

   textureName = "special/Smoke/bigSmoke";

   colors[0]     = "1.0 1.0 0.0 1.0";
   colors[1]     = "0.2 0.2 0.2 1.0";
   colors[2]     = "0.2 0.2 0.2 0.5";
   sizes[0]      = 5.0;
   sizes[1]      = 3.0;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(WidowMakerSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 3;

   ejectionVelocity = 2.25;
   velocityVariance = 0.55;

   thetaMin         = 0.0;
   thetaMax         = 40.0;

   particles = "WidowMakerSmokeParticle";
};


//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock GrenadeProjectileData(WidowMakerShot)
{
   projectileShapeName = "bomb.dts";
   scale               = "2.0 2.0 2.0";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 1.0;
   damageRadius        = 200.0;
   radiusDamageType    = $DamageType::Nuke;
   kickBackStrength    = 45000;

   explosion           = "WidowMakerExplosion";
   underwaterExplosion = "UnderwaterMortarExplosion";
   velInheritFactor    = 0.5;
   splash              = MortarSplash;
   depthTolerance      = 200.0; // depth at which it uses underwater explosion

      
   baseEmitter         = WidowMakerSmokeEmitter;
   bubbleEmitter       = MortarBubbleEmitter;
      
   grenadeElasticity = 0.15;
   grenadeFriction   = 0.4;
   armingDelayMS     = 9000;
   muzzleVelocity    = 43.7;
   drag              = 0.1;

   sound			 = WidowMakerProjectileSound;

   hasLight    = true;
   lightRadius = 9.0;
   lightColor  = "1.0 1.0 0.0 1.0";

   hasLightUnderwaterColor = true;
   underWaterLightColor = "0.05 0.075 0.2";

};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(WidowMakerAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some Widow Maker ammo";

   computeCRC = true;

};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(WidowMaker)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "turret_mortar_large.dts";
   image = WidowMakerImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a Widow Maker";

   computeCRC = true;
   emap = true;
};

datablock ShapeBaseImageData(WidowMakerImage)
{
   className = WeaponImage;
   shapeFile = "turret_mortar_large.dts";
   item = WidowMaker;
   ammo = WidowMakerAmmo;
   offset = "0 0 0";
   emap = true;

   projectile = WidowMakerShot;
   projectileType = GrenadeProjectile;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = WidowMakerSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Delay";
   //stateSound[2] = MortarIdleSound;

   stateName[3] = "Delay";
   stateTimeoutValue[3] = 15.0; // --- Wait for 15 seconds
   stateSound[3] = chargingDelaySound;
   stateTransitionOnTimeout[3] = "Fire";

   stateName[4] = "Fire";
   stateSequence[4] = "Recoil";
   stateTransitionOnTimeout[4] = "Reload";
   stateTimeoutValue[4] = 2.0;
   stateFire[4] = true;
   stateRecoil[4] = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4] = "onFire";
   stateSound[4] = WidowMakerFireSound;

   stateName[5] = "Reload";
   stateTransitionOnNoAmmo[5] = "NoAmmo";
   stateTransitionOnTimeout[5] = "Ready";
   stateTimeoutValue[5] = 2.0;
   stateAllowImageChange[5] = false;
   stateSequence[5] = "Reload";
   stateSound[5] = MortarReloadSound;

   stateName[6] = "NoAmmo";
   stateTransitionOnAmmo[6] = "Reload";
   stateSequence[6] = "NoAmmo";
   stateTransitionOnTriggerDown[6] = "DryFire";

   stateName[7]       = "DryFire";
   stateSound[7]      = MortarDryFireSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "NoAmmo";
};

datablock ItemData(MidRiserExplosion) //name it whatever u want 
{
  shapeFile = "turret_muzzlepoint.dts";
  hasDamageRadius     = false;
  explosion = MiddleExplosion; 
};

datablock ItemData(TopExplosion) //name it whatever u want 
{ 
  shapeFile = "turret_muzzlepoint.dts"; 
  hasDamageRadius     = false;
  explosion = WidowMakerTopExplosion; 
};

function WidowMakerShot::onExplode(%data, %proj, %pos, %mod) 
{ 
  if(%data.hasDamageRadius) 
   RadiusExplosion(%proj, %pos, %data.damageRadius, %data.indirectDamage, %data.kickBackStrength, %proj.sourceObject, %data.RadiusDamageType); 

   %pos1 = VectorAdd(%pos, "0 0 60"); 
   %pos2 = VectorAdd(%pos, "0 0 85");
   %pos3 = VectorAdd(%pos, "0 0 115");
   %pos4 = VectorAdd(%pos, "0 0 145");
   %pos5 = VectorAdd(%pos, "0 0 175");
   %pos6 = VectorAdd(%pos, "0 0 185"); 

   %exp2 = new Item() 
   { 
    datablock = MidRiserExplosion;  
    position = %pos1; 
   };

   %exp3 = new Item() 
   { 
    datablock = MidRiserExplosion;  
    position = %pos2; 
   };  

   %exp4 = new Item() 
   { 
    datablock = MidRiserExplosion;  
    position = %pos3; 
   };

   %exp5 = new Item() 
   { 
    datablock = MidRiserExplosion;  
    position = %pos4; 
   }; 

   %exp6 = new Item() 
   { 
    datablock = MidRiserExplosion;  
    position = %pos5; 
   }; 

   %exp7 = new Item() 
   { 
    datablock = TopExplosion;  
    position = %pos6; 
   };   

   MissionCleanup.add(%exp2); 
   MissionCleanup.add(%exp3);
   MissionCleanup.add(%exp4); 
   MissionCleanup.add(%exp5);
   MissionCleanup.add(%exp6);
   MissionCleanup.add(%exp7); 
   schedule(100, 0, detonateGrenade, %exp2); 
   schedule(200, 0, detonateGrenade, %exp3);
   schedule(300, 0, detonateGrenade, %exp4); 
   schedule(400, 0, detonateGrenade, %exp5);
   schedule(500, 0, detonateGrenade, %exp6);
   schedule(600, 0, detonateGrenade, %exp7);  
} 
