//---------------------------------------------------
//Tactical nuke, thrown by hand
//---------------------------------------------------

datablock AudioProfile(TacticalNukeExplosionSound)
{
   filename = "fx/bonuses/down_passback3_rocket.wav";
   description = AudioBIGExplosion3d;
   preload = true;
   effect = SatchelChargeExplosionEffect;
};

datablock AudioProfile(TacticalNuke2ExplosionSound)
{
   filename = "fx/bonuses/upward_passback1_bomb.wav";
   description = AudioBIGExplosion3d;
   preload = true;
   effect = SatchelChargeExplosionEffect;
};

//---------------------------------------------------------------------------
// Underwater stuff
//---------------------------------------------------------------------------
datablock ShockwaveData(UnderwaterTactShockwave)
{
   width = 6.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 10;
   acceleration = 20.0;
   lifetimeMS = 900;
   height = 1.0;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.4 0.4 1.0 0.50";
   colors[1] = "0.4 0.4 1.0 0.25";
   colors[2] = "0.4 0.4 1.0 0.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};



//---------------------------------------------------------------------------
// Underwater Explosion
//---------------------------------------------------------------------------
datablock ParticleData(UnderwaterTactExpSparks)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;
   textureName          = "special/crescent3";
   colors[0]     = "0.4 0.4 1.0 1.0";
   colors[1]     = "0.4 0.4 1.0 1.0";
   colors[2]     = "0.4 0.4 1.0 0.0";
   sizes[0]      = 7.0;
   sizes[1]      = 7.0;
   sizes[2]      = 7.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(UnderwaterTactExpSparksEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 17;
   velocityVariance = 4;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "UnderwaterTactExpSparks";
};

datablock ParticleData(TactExplosionBubbleParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.25;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 600;
   useInvAlpha          = false;
   textureName          = "special/bubbles";

   spinRandomMin        = -100.0;
   spinRandomMax        =  100.0;

   colors[0]     = "0.7 0.8 1.0 0.0";
   colors[1]     = "0.7 0.8 1.0 0.4";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 20.0;
   sizes[1]      = 20.0;
   sizes[2]      = 20.0;
   times[0]      = 0.0;
   times[1]      = 0.8;
   times[2]      = 1.0;
};
datablock ParticleEmitterData(TactExplosionBubbleEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 20.0;
   ejectionOffset   = 7.0;
   velocityVariance = 0.5;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "TactExplosionBubbleParticle";
};

datablock DebrisData( UnderwaterTactDebris )
{
   emitters[0] = MortarExplosionBubbleEmitter;

   explodeOnMaxBounce = true;

   elasticity = 0.4;
   friction = 0.2;

   lifetime = 1.5;
   lifetimeVariance = 0.2;

   numBounces = 1;
};             

datablock ExplosionData(UnderwaterTactSubExplosion1)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;
   delayMS = 100;
   offset = 3.0;
   playSpeed = 1.5;

   sizes[0] = "7.5 7.5 7.5";
   sizes[1] = "10.0  10.0  10.0";
   sizes[2] = "5.0 5.0 5.0";
   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

};             

datablock ExplosionData(UnderwaterTactSubExplosion2)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;
   delayMS = 50;
   offset = 3.0;
   playSpeed = 0.75;

   sizes[0] = "11.5 11.5 11.5";
   sizes[1] = "11.5 11.5 11.5";
   sizes[2] = "10.0 10.0 10.0";
   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;
};

datablock ExplosionData(UnderwaterTactSubExplosion3)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;
   delayMS = 0;
   offset = 0.0;
   playSpeed = 0.5;

   sizes[0] = "10.0 10.0 10.0";
   sizes[1] = "20.0 20.0 20.0";
   sizes[2] = "15.0 15.0 15.0";
   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

};

datablock ExplosionData(UnderwaterTactExplosion)
{
   soundProfile   = UnderwaterMortarExplosionSound;

   shockwave = UnderwaterTactShockwave;
   shockwaveOnTerrain = true;

   subExplosion[0] = UnderwaterTactSubExplosion1;
   subExplosion[1] = UnderwaterTactSubExplosion2;
   subExplosion[2] = UnderwaterTactSubExplosion3;

   emitter[0] = TactExplosionBubbleEmitter;
   emitter[1] = UnderwaterTactExpSparksEmitter;
   
   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};


//--------------------------------------------------------------
// DEBRIS FIRE PARTICLES
//--------------------------------------------------------------

datablock ParticleData(TacticalNukeDebrisFireParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;

   lifetimeMS           = 350;
   lifetimeVarianceMS   = 0;

   textureName          = "particleTest";

   useInvAlpha = false;
   spinRandomMin = -160.0;
   spinRandomMax = 160.0;

   animateTexture = true;
   framesPerSec = 15;


   animTexName[0]       = "special/Explosion/exp_0016";
   animTexName[1]       = "special/Explosion/exp_0018";
   animTexName[2]       = "special/Explosion/exp_0020";
   animTexName[3]       = "special/Explosion/exp_0022";
   animTexName[4]       = "special/Explosion/exp_0024";
   animTexName[5]       = "special/Explosion/exp_0026";
   animTexName[6]       = "special/Explosion/exp_0028";
   animTexName[7]       = "special/Explosion/exp_0030";
   animTexName[8]       = "special/Explosion/exp_0032";

   colors[0]     = "1.0 0.7 0.5 1.0";
   colors[1]     = "1.0 0.5 0.2 1.0";
   colors[2]     = "1.0 0.25 0.1 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 2.0;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(TacticalNukeDebrisFireEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 1;

   ejectionVelocity = 0.25;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 30.0;

   particles = "TacticalNukeDebrisFireParticle";
};

//--------------------------------------------------------------
// DEBRIS SMOKE PARTICLES
//--------------------------------------------------------------


datablock ParticleData( TacticalNukeDebrisSmokeParticle )
{
   dragCoeffiecient     = 4.0;
   gravityCoefficient   = -0.00;   // rises slowly
   inheritedVelFactor   = 0.2;

   lifetimeMS           = 1000;  
   lifetimeVarianceMS   = 100;   // ...more or less

   textureName          = "particleTest";

   useInvAlpha =     true;

   spinRandomMin = -50.0;
   spinRandomMax = 50.0;

   colors[0]     = "0.9 0.0 0.0 0.0";
   colors[1]     = "0.4 0.1 0.1 1.0";
   colors[2]     = "0.1 0.1 0.1 0.0";
   sizes[0]      = 2;
   sizes[1]      = 3;
   sizes[2]      = 5;
   times[0]      = 0.0;
   times[1]      = 0.7;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( TacticalNukeDebrisSmokeEmitter )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 5;

   ejectionVelocity = 1.0;  // A little oomph at the back end
   velocityVariance = 0.5;

   thetaMin         = 10.0;
   thetaMax         = 30.0;

   useEmitterSizes = true;

   particles = "TacticalNukeDebrisSmokeParticle";
};


datablock ExplosionData(TacticalNukeDebrisExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   soundProfile = plasmaExpSound;
   faceViewer = true;
   explosionScale = "0.4 0.4 0.4";
};

datablock DebrisData( TacticalNukeFireballDebris )
{
   emitters[0] = TacticalNukeDebrisSmokeEmitter;
   emitters[1] = TacticalNukeDebrisFireEmitter;

   explosion = TacticalNukeDebrisExplosion;
   explodeOnMaxBounce = true;

   elasticity = 0.4;
   friction = 0.2;

   lifetime = 100.0;
   lifetimeVariance = 30.0;

   numBounces = 0;
   bounceVariance = 0;
};  

datablock ShockwaveData(TacticalNukeShockwave)
{
   width = 18.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 25;
   acceleration = 30.0;
   lifetimeMS = 4000;
   height = 8;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.9 0.0 0.0 1.0";
   colors[1] = "0.9 0.0 0.0 1.0";
   colors[2] = "0.9 0.0 0.0 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = false;
};

datablock ShockwaveData(TacticalNuke2Shockwave)
{
   width = 18.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 25;
   acceleration = 30.0;
   lifetimeMS = 4000;
   height = 1;
   verticalCurve = 0.5;
   is2D = true;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.9 0.0 0.0 1.0";
   colors[1] = "0.9 0.0 0.0 1.0";
   colors[2] = "0.9 0.0 0.0 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = false;
};


//--------------------------------------------------------------------------
// TacticalNuke Explosion Particle effects
//--------------------------------------

datablock ParticleData(TacticalNukeExplosionSmoke)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = -0.0;   // rises slowly
   inheritedVelFactor   = 0.025;

   lifetimeMS           = 2250;
   lifetimeVarianceMS   = 500;

   textureName          = "particleTest";

   useInvAlpha =  true;
   spinRandomMin = -100.0;
   spinRandomMax =  100.0;

   textureName = "special/Smoke/bigSmoke";

   colors[0]     = "0.9 0.1 0.1 1.0";
   colors[1]     = "0.4 0.1 0.1 1.0";
   colors[2]     = "0.1 0.1 0.1 0.5";
   colors[3]     = "0.1 0.1 0.1 0.0";
   sizes[0]      = 7.5;
   sizes[1]      = 9.0;
   sizes[2]      = 15.0;
   sizes[3]      = 18.0;
   times[0]      = 0.0;
   times[1]      = 0.333;
   times[2]      = 0.666;
   times[3]      = 1.0;

};

datablock ParticleEmitterData(TacticalNukeExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 8.0;


   ejectionVelocity = 30.0;
   velocityVariance = 1.2;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "TacticalNukeExplosionSmoke";

};

//---------------------------------------------------------------------------
// Explosion
//---------------------------------------------------------------------------

datablock ExplosionData(TacticalNukeSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   soundProfile   = TacticalNukeExplosionSound;

   debris = TacticalNukeFireballDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 8;
   debrisNumVariance = 1;
   debrisVelocity = 42.0;
   debrisVelocityVariance = 5.0;

   delayMS = 100;

   offset = 5.0;

   playSpeed = 1.5;

   sizes[0] = "20.0 20.0 20.0";
   sizes[1] = "20.0 20.0 20.0";
   times[0] = 0.0;
   times[1] = 1.0;

};             

datablock ExplosionData(TacticalNukeSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   soundProfile   = TacticalNuke2ExplosionSound;

   debris = TacticalNukeFireballDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 8;
   debrisNumVariance = 1;
   debrisVelocity = 42.0;
   debrisVelocityVariance = 5.0;

   delayMS = 50;

   offset = 5.0;

   playSpeed = 1.0;

   sizes[0] = "20.0 20.0 20.0";
   sizes[1] = "20.0 20.0 20.0";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(TacticalNukeSubExplosion3)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   soundProfile   = TacticalNukeExplosionSound;

   shockwave = TacticalNuke2Shockwave;
   shockwaveOnTerrain = false;

   debris = TacticalNukeFireballDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 8;
   debrisNumVariance = 1;
   debrisVelocity = 42.0;
   debrisVelocityVariance = 5.0;

   delayMS = 0;
   offset = 0.0;
   playSpeed = 0.7;

   sizes[0] = "20.0 20.0 20.0";
   sizes[1] = "20.0 20.0 20.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(TacticalNukeExplosion)
{
   soundProfile   = TacticalNukeExplosionSound;

   shockwave = TacticalNukeShockwave;
   shockwaveOnTerrain = false;

   subExplosion[0] = TacticalNukeSubExplosion1;
   subExplosion[1] = TacticalNukeSubExplosion2;
   subExplosion[2] = TacticalNukeSubExplosion3;

   emitter[0] = TacticalNukeExplosionSmokeEmitter;
   //emitter[1] = MortarCrescentEmitter; maybe too pretty for a big boom? - RED
   //emitter[2] = MortarCrescent2Emitter;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};

//--------------------
//TacticalNuke thrown
//--------------------

datablock ItemData(TacticalNukeThrown)
{
	className = Weapon;
	shapeFile = "stackable1s.dts";
	mass = 0.7;
	elasticity = 0.2;
   friction = 1;
   pickupRadius = 2;
   maxDamage = 0.5;
	explosion = TacticalNukeExplosion;
	underwaterExplosion = UnderwaterTactExplosion;
      depthTolerance      = 5.0;
   
   indirectDamage      = 1.0;
   damageRadius        = 55.0;
   radiusDamageType    = $DamageType::Tactical;
   kickBackStrength    = 8000;
   
   computeCRC = true;
   sticky = true;

};

datablock ItemData(TacticalNuke)
{
	className = HandInventory;
	catagory = "Handheld";
	shapeFile = "grenade.dts";
	mass = 0.7;
	elasticity = 0.2;
   friction = 1;
   pickupRadius = 2;
   thrownItem = TacticalNukeThrown;
	pickUpName = "a tactical nuke";
	isGrenade = true;

   computeCRC = true;

};

function TacticalNukeThrown::onThrow(%this, %gren, %obj, %tactical)
{
AIGrenadeThrown(%gren);
%gren.detThread = schedule(10000, %gren, "detonateGrenade", %gren);
messageClient(%obj.client, 'MsgTactNukeSet', '\c2Tactical nuke sequence started, detonation in 10 seconds.');
}           